diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index 1726a51bf..0b45bd9fb 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -5,6 +5,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
@@ -238,35 +239,69 @@ public class PacketHandlerLogin extends PacketHandler
 
     @Override
     public void handlePingHandshake(PacketPingHandshake pingHandshakePacket) {
-        String msg = "";
-        if (pingHandshakePacket.pingHostString.equals("MC|PingHost")) {
-            msg =
-                "§1" +
-                '\0' +
-                0 +
-                '\0' +
-                "BTA " + Global.VERSION +
-                '\0' +
-                mcServer.motd +
-                '\0' +
-                0 +
-                '\0' +
-                0;
-        } else if (pingHandshakePacket.pingHostString.equals("BTAPingHost")) {
-            msg =
-                "§1" +
-                '\0' +
-                Global.MP_PROTOCOL_VERSION +
-                '\0' +
-                Global.VERSION +
-                '\0' +
-                mcServer.motd +
-                '\0' +
-                mcServer.playerList.playerEntities.size() +
-                '\0' +
-                mcServer.maxPlayers;
+        StringBuilder msg = new StringBuilder();
+        switch (pingHandshakePacket.pingHostString) {
+            case "MC|PingHost":
+                msg
+                    .append("§1").append('\0')
+                    .append(0).append('\0')
+                    .append("BTA ").append(Global.VERSION).append('\0')
+                    .append(mcServer.motd).append('\0')
+                    .append(0).append('\0')
+                    .append(0);
+                break;
+            case "BTAPingHost":
+                switch (pingHandshakePacket.payload) {
+                    case 0x02: {
+                        msg
+                            .append("§1").append('\0')
+                            .append(Global.MP_PROTOCOL_VERSION).append('\0')
+                            .append(Global.VERSION).append('\0')
+                            .append(mcServer.motd).append('\0')
+                            .append(mcServer.playerList.playerEntities.size()).append('\0')
+                            .append(mcServer.maxPlayers).append('\0')
+                            .append(mcServer.name).append('\0');
+                        if (mcServer.broadcastPlayerList) {
+                            for (Player player : mcServer.playerList.playerEntities) {
+                                msg.append(player.username).append(",");
+                            }
+                        }
+                        break;
+                    }
+                    case 0x03: {
+                        msg
+                            .append("§1").append('\0')
+                            .append(Global.MP_PROTOCOL_VERSION).append('\0')
+                            .append(Global.VERSION).append('\0')
+                            .append(mcServer.motd).append('\0')
+                            .append(mcServer.playerList.playerEntities.size()).append('\0')
+                            .append(mcServer.maxPlayers).append('\0')
+                            .append(mcServer.name).append('\0');
+                        if (mcServer.broadcastPlayerList) {
+                            for (Player player : mcServer.playerList.playerEntities) {
+                                msg.append(player.username).append(",");
+                            }
+                        }
+                        if (mcServer.iconBytes != null) {
+                            netManager.addToSendQueue(new PacketServerIcon(mcServer.iconBytes));
+                        }
+                        break;
+                    }
+                    case 0x01:
+                    default: {
+                        msg
+                            .append("§1").append('\0')
+                            .append(Global.MP_PROTOCOL_VERSION).append('\0')
+                            .append(Global.VERSION).append('\0')
+                            .append(mcServer.motd).append('\0')
+                            .append(mcServer.playerList.playerEntities.size()).append('\0')
+                            .append(mcServer.maxPlayers);
+                        break;
+                    }
+                }
+                break;
         }
-        kickUser(msg, true);
+        kickUser(msg.toString(), true);
     }
 
     @Override
